// Projektarbeit Stoppuhr & Wecker
// Gysin & Keo
// 05.11.2001

#include "ioh83067.h"
#include "i2c.h"

#define Schalter (*(volatile unsigned char*)(0x400030))

// Funktionen
void SendStartCondition(void);
void SendStopCondition(void);
void SendByte(char byte);
char ReceiveByte(void);
char ReceiveAck(void);
void SendAck(char Bit);
void Clockpulse(void);
void SetSCL(char Bit);
void SetSDA(char Bit);
char GetSDA(void);
volatile void Delay(long int us);        // Wartefunktion
char BCDTODEC(char BCD); // BCD => Decimal Konvertierung
char DECTOBCD(char DEC); // Decimal => BCD Konvertierung
char GetI2CByte(char SlaveAddr, char Address);
void PutI2CByte(char SlaveAddr, char Address, char Data);
void SendStartCondition(void)
  {
  SetSCL(1); // Clock = 1
  SetSDA(1); // Daten = 1
  
  Delay(5); // 5us warten
  SetSDA(0);
  Delay(4);
  SetSCL(0);
  }
void SendStopCondition(void)
  {
  SetSCL(0);
  SetSDA(0);
  Delay(4);
  SetSCL(1);
  Delay(4);
  SetSDA(1);
  Delay(4);
  PBDDR = PBDDR & 254; // PB.0 als Input definieren
  PBDDR = PBDDR & 253; // PB.1 als Input definieren
  }
void SendByte(char byte)
  {
  char i;
  char sendebyte;
  for (i=0; i<8; i++)
    {
    sendebyte = (byte & 128) >> 7;
    SetSDA(sendebyte);
    Clockpulse();
    byte = byte << 1;
    }
  }
char ReceiveByte(void)
  {
  char i;
  char b;
  
  b = 0;
  //SetSDA(1);
  PBDDR = PBDDR & 254; // PB.0 als Input definieren
  for (i=0; i<8; i++)
    {
    SetSCL(0);
    Delay(4);
    SetSCL(1);
    Delay(4);
    
    b = b << 1;
    if (GetSDA() == 1)
      {
      b = b | 1;
      }
    else
      {
      b = b & 254;
      }
    SetSCL(0);
    }
  return (b);
  }
char ReceiveAck(void)
  {
  char i = 140; // Solange muss SDA 1 sein...
  
  //Delay(4);
  do
    {
    }
  while ((GetSDA() == 1) && (--i));
  Clockpulse();
  if (i == 0)
    {
    return (1);
    }
  else
    {
    return (0);
    }
  }
void SendAck(char Bit)
  {
  if (Bit = 1)
    {
    SetSDA(0);
    }
  else
    {
    SetSDA(1);
    }
  Clockpulse;
  SetSDA(1);
  }
void Clockpulse(void)
  {
  SetSCL(0);
  Delay(4);
  SetSCL(1);
  Delay(4);
  SetSCL(0);
  Delay(4);
  }
void SetSCL(char Bit)
  {
  PBDDR = PBDDR | 2; // PB.1 als Output definieren
  if (Bit == 0)
    {
    PBDR = PBDR & 253; // PB.1 auf 0 setzen
    }
  else
    {
    PBDR = PBDR | 2; // PB.1 auf 1 setzen
    }
  }
void SetSDA(char Bit)
  {
  PBDDR = PBDDR | 1; // PB.0 als Output definieren
  if (Bit == 0)
    {
    PBDR = PBDR & 254; // PB.0 auf 0 setzen
    }
  else
    {
    PBDR = PBDR | 1; // PB.0 auf 1 setzen
    }
  }
volatile void Delay(long int us)
  {
  long int i;
  long int x;
  for (i=0; i<us; i++)
    {
    for (x=0; x<100; x++)
      {
      }
    }
  }
char GetSDA(void)
  {
  PBDDR = PBDDR & 254; // PB.0 als Input definieren
  if ((PBDR & 1) == 1)
    {
    return (1);
    }
  else
    {
    return (0);
    }
  }
char BCDTODEC(char BCD)
  {
  char stelle0;
  char stelle1;
  
  stelle0 = BCD & 15;   // Obere 4 Bit ausmaskieren
  stelle1 = (BCD & 240) >> 4; // Untere 4 Bit ausmaskieren
  return ((stelle1 * 10) + stelle0);
  }
char DECTOBCD(char DEC)
  {
  char stelle0;
  char stelle1;
  char ergebnis;
  
  stelle0 = DEC % 10;
  DEC = DEC - stelle0;
  DEC = DEC / 10;
  stelle1 = DEC;
  
  ergebnis = stelle0 + (stelle1 << 4);
  return (ergebnis);
  }
char GetI2CByte(char SlaveAddr, char Address)
  {
  char received;
  volatile char dummy;
  
  SendStartCondition();
  SendByte(SlaveAddr + 0); // Slave-Adresse + R/W = 0 (Write)
  dummy = ReceiveAck();
  SendByte(Address);
  dummy = ReceiveAck();
  SendStartCondition();
  SendByte(SlaveAddr + 1); // Slave-Adresse + R/W = 1 (Read) 
  dummy = ReceiveAck();
  received = ReceiveByte();
  SendAck(1);
  SendStopCondition();
  return (received);
  }
void PutI2CByte(char SlaveAddr, char Address, char Data)
  {
  SendStartCondition();
  SendByte(SlaveAddr); // Slave-Adresse + R/W = 0 (Write)
  ReceiveAck();
  SendByte(Address);
  ReceiveAck();
  SendByte(Data); // Daten senden 
  ReceiveAck();
  SendStopCondition();
  
  //SendStartCondition();
  //SendByte(SlaveAddr); // Slave-Adresse + R/W = 0 (Write)
  //ReceiveAck();
  //SendByte(Address);
  //ReceiveAck();
  //SendStartCondition();
  //SendByte(SlaveAddr); // Slave-Adresse + R/W = 0 (Write)
  //ReceiveAck();
  //SendByte(Data); // Daten senden 
  //ReceiveAck();
  //SendStopCondition();
  }
